#!/bin/bash

export RSAD_ROOT=/raid/rsad
export RSAD_DATASET=ersst

####################################################################################
#### Create the environment variables for the dataset                           ####
#### Do not change these declarations, change the ROOT and DATASET values above ####
####################################################################################

echo $RSAD_ROOT
echo $RSAD_DATASET

export ${RSAD_DATASET}_HOME=${RSAD_ROOT}/${RSAD_DATASET}
eval "echo \$$(echo ${RSAD_DATASET}_HOME)"

export ${RSAD_DATASET}_BIN_DIR=${RSAD_ROOT}/${RSAD_DATASET}/bin
eval "echo \$$(echo ${RSAD_DATASET}_BIN_DIR)"

export ${RSAD_DATASET}_DAT_DIR=${RSAD_ROOT}/${RSAD_DATASET}/data
eval "echo \$$(echo ${RSAD_DATASET}_DAT_DIR)"

export ${RSAD_DATASET}_ETC_DIR=${RSAD_ROOT}/${RSAD_DATASET}/etc
eval "echo \$$(echo ${RSAD_DATASET}_ETC_DIR)"

export ${RSAD_DATASET}_LIB_DIR=${RSAD_ROOT}/${RSAD_DATASET}/lib
eval "echo \$$(echo ${RSAD_DATASET}_LIB_DIR)"

export ${RSAD_DATASET}_LOG_DIR=${RSAD_ROOT}/${RSAD_DATASET}/logs
eval "echo \$$(echo ${RSAD_DATASET}_LOG_DIR)"

export ${RSAD_DATASET}_SCRP_DIR=${RSAD_ROOT}/${RSAD_DATASET}/script
eval "echo \$$(echo ${RSAD_DATASET}_SCRP_DIR)"

export ${RSAD_DATASET}_SRC_DIR=${RSAD_ROOT}/${RSAD_DATASET}/src
eval "echo \$$(echo ${RSAD_DATASET}_SRC_DIR)"

export ${RSAD_DATASET}_FTP_DIR=${RSAD_ROOT}/${RSAD_DATASET}/ftp
eval "echo \$$(echo ${RSAD_DATASET}_FTP_DIR)
"
#### Create FORTRAN environment variables and paths ################################
. /usr/local/lf9562/bash_setup 

#### POSSIBLE REMOVAL ##############################################################

#### GrADS environ variabes, these should be in .bash_profile or .bashrc ###########--
export GASCRP=/usr/local/grads/current/bin
export GADDIR=/usr/local/grads/current/data

#export PATH=$PATH:/usr/local/netcdf/bin
#export NFf90=/usr/local/netcdf
################## uncomment next 2 lines to use local
PATH=$PATH:/usr/local/netcdf/bin
export NFf90=/usr/local/netcdf-4.1.1
#ice_dir is the location of 
export ${RSAD_DATASET}_ice_dir=/raid2/sstday
#PATH=$NFf90:$PATH

#export nf90_mod=/usr/local/netcdf/src/f90

###############uncomment next 2 lines to point to Liu's home netcdf lib
#PATH=$PATH:/home/cliu/netcdf/netcdf-3.6.0-p1/f90/bin
#export NFf90=/home/cliu/netcdf/netcdf-3.6.0-p1/f90

#######point to special install of netcdf lib in viva's home
#PATH=$PATH:/home/pbanzon/apps/bin/
#export NFf90=/home/pbanzon/apps/

