#!/bin/bash
#. /raid/rsad/ersst/script/ersst_config.sh

#  Get monthly buoyship data nqyyyy.mm.gz

chyr=`date --date="last month" +%y`
chmon=`date --date="last month" +%m`


echo "The FTP month is: $chyr $chmon"

#### Build FTP file to get NCEP data ##########################################
# ftp://ftp.emc.ncep.noaa.gov/cmb/obs/gts/gts.sfcmar.gz
echo "Getting NCEP data by anonymous FTP"
echo "open ftp.emc.ncep.noaa.gov" > ftpin
echo "user anonymous your.email@example.com" >> ftpin
echo "cd /cmb/obs/gts" >> ftpin
echo "bin" >> ftpin
echo "prompt" >> ftpin
echo "get gts.sfcmar.gz $ersst_FTP_DIR/buoyship/nq"$chyr""$chmon".gz" >> ftpin
echo "quit" >> ftpin
ftp -ivn < ftpin

#### Was the file retrieved? If not, get it from the other site ###############
if [ -f $ersst_FTP_DIR/buoyship/nq"$chyr""$chmon".gz ]
then
   echo "gts.sfcmar.gz exists, retrieved and renamed to nq"$chyr""$chmon".gz"
   rm $ersst_FTP_DIR/buoyship/nq"$chyr""$chmon" >> ersst_errors
   gunzip $ersst_FTP_DIR/buoyship/nq"$chyr""$chmon".gz

else
   echo "gts.sfcmar.gz does not exist"
   echo "trying cdc ftp site: ftp.cdc.noaa.gov"
   echo "open ftp.cdc.noaa.gov" > ftpin
   echo "user anonymous your.email@example.com" >> ftpin
   echo "cd /pub/Public/coads/ncep_obs" >> ftpin
   echo "bin" >> ftpin
   echo "prompt" >> ftpin
   echo "get nq"$chyr$chmon".gz $ersst_FTP_DIR/buoyship/nq"$chyr""$chmon".gz" >> ftpin
   echo "quit" >> ftpin
   ftp -ivn < ftpin

   if [ -f $ersst_FTP_DIR/buoyship/nq"$chyr""$chmon".gz ]
   then
      echo "nq"$chyr""$chmon".gz file is found"
      rm $ersst_FTP_DIR/buoyship/nq"$chyr""$chmon" >> ersst_errors
      gunzip $ersst_FTP_DIR/buoyship/nq"$chyr""$chmon.gz"
   else
      echo "RED-STOP: cdc buoy ship data nqyymm.gz does not exist either"
   fi
fi


#### end of getting data for the buoy ship quarterly run ######################

